// getControllertypeConfiguration

if (raisedEvent.parameter.actions == 'sync') {
	if (Property.getNode('/scripts/system-addon-remote-connectivity/OSPToken') == null) {
		lWarn.logln('cloud not active, just waiting a little longer');
		new Event('heating-controller.cloud',{actions:'sync',time:'+60'}).raise();
	} else {
		var handle = new WebserviceConnection(),
			languageDss = Property.getProperty('/system/language/locale');
        if (!languageDss) {
            languageDss = en_US;
        }
		handle.simplerequest('public/dss/v1_1/DSSHeating/GetControllerPIDConfigurationTemplate', 'language=' + languageDss, 'GET', true, function(code, data) {
			if (code === 200) {
				lInfo.logln(': OK [' + code + ']');
			} else {
				lInfo.logln(': FAILED! Server replied: "' + code + '"');
			}
			lInfo.logln(data);
			var oValue = (JSON.parse(data)).Response.ControllerTypeConfigurationList;
			Property.getNode('/scripts/heating-controller').removeChild('controllerDefinitions');
			for ( var iIndex = 0; iIndex < oValue.length; iIndex++) {
				var oVal = oValue[iIndex];
				var id = oVal.HeatingControllerTypeId;
				var templateType = oVal.HeatingControllerType;
				storeParameter('controllerDefinitions/' + id + '/id', id);
				storeParameter('controllerDefinitions/' + id + '/type', templateType);
				storeParameter('controllerDefinitions/' + id + '/controllerMode', 1);
				storeParameter('controllerDefinitions/' + id + '/name', oVal.DisplayName);
				storeParameter('controllerDefinitions/' + id + '/kp', "" + oVal.CtrlKp);
				storeParameter('controllerDefinitions/' + id + '/ts', "" + oVal.CtrlTs);
				storeParameter('controllerDefinitions/' + id + '/kd', "" + oVal.CtrlKd);
				storeParameter('controllerDefinitions/' + id + '/ti', "" + oVal.CtrlTi);
				storeParameter('controllerDefinitions/' + id + '/imin', "" + oVal.CtrlImin);
				storeParameter('controllerDefinitions/' + id + '/imax', "" + oVal.CtrlImax);
				storeParameter('controllerDefinitions/' + id + '/ymin', Math.floor(oVal.CtrlYmin + 0.5));
				storeParameter('controllerDefinitions/' + id + '/ymax', Math.floor(oVal.CtrlYmax + 0.5));
				storeParameter('controllerDefinitions/' + id + '/antiwindup', oVal.CtrlAntiWindup ? 1 : 0);
				storeParameter('controllerDefinitions/' + id + '/keepfloorwarm', oVal.CtrlKeepFloorWarm ? 1 : 0);
				if (oVal.emergencyValue!=null) {
					storeParameter('controllerDefinitions/' + id + '/emergency', oVal.emergencyValue);
				} else {
					storeParameter('controllerDefinitions/' + id + '/emergency', 75);
				}
			}
		});
	}
}
